vim.api.nvim_create_autocmd('LspAttach', {
  group = vim.api.nvim_create_augroup('lsp-attach', { clear = true }),
  callback = function(args)
    local opts = { buffer = args.buf }
    vim.keymap.set('n', 'gD', vim.lsp.buf.declaration, opts)
    vim.keymap.set('n', 'gd', vim.lsp.buf.definition, opts)
    vim.keymap.set('n', 'gi', vim.lsp.buf.implementation, opts)
    vim.keymap.set('n', 'gr', vim.lsp.buf.references, opts)
    vim.keymap.set('n', 'K', vim.lsp.buf.hover, opts)
    vim.keymap.set('n', 'rn', vim.lsp.buf.rename, opts)
    vim.keymap.set('n', '<C-i>', vim.lsp.buf.signature_help, opts)
    vim.keymap.set('n', '<C-k>', vim.lsp.buf.format, opts)
  end,
})


-- Python config

vim.api.nvim_create_autocmd('FileType', {
  pattern = 'python',
  group = vim.api.nvim_create_augroup('lsp-python', { clear = true }),
  callback = function(args)
    vim.lsp.start({
      name = 'pyright',
      cmd = {'pyright-langserver', '--stdio'},
      -- uncomment after upgrading neovim > 0.10
      --root_dir = vim.fs.root(args.buf, {'setup.py', 'pyproject.toml'}),
      root_dir = vim.fs.dirname(vim.fs.find({'setup.py', 'pyproject.toml'}, { upward = true })[1]),
    })
    vim.lsp.start({
      name = 'ruff',
      cmd = {'ruff', 'server'},
      -- uncomment after upgrading neovim > 0.10
      --root_dir = vim.fs.root(args.buf, {'setup.py', 'pyproject.toml'}),
      root_dir = vim.fs.dirname(vim.fs.find({'setup.py', 'pyproject.toml'}, { upward = true })[1]),
    })
  end,
})
